gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.ListBox

Contents

- Exported types
- Methods
  - bindModel
  - dragHighlightRow
  - dragUnhighlightRow
  - getActivateOnSingleClick
  - getAdjustment
  - getRowAtIndex
  - getRowAtY
  - getSelectedRow
  - getSelectedRows
  - getSelectionMode
  - insert
  - invalidateFilter
  - invalidateHeaders
  - invalidateSort
  - new
  - prepend
  - selectAll
  - selectRow
  - selectedForeach
  - setActivateOnSingleClick
  - setAdjustment
  - setFilterFunc
  - setHeaderFunc
  - setPlaceholder
  - setSelectionMode
  - setSortFunc
  - unselectAll
  - unselectRow
- Properties
  - activateOnSingleClick
  - selectionMode
- Signals
  - activateCursorRow
  - moveCursor
  - rowActivated
  - rowSelected
  - selectAll
  - selectedRowsChanged
  - toggleCursorRow
  - unselectAll

Description

A GtkListBox is a vertical container that contains GtkListBoxRow children. These rows can be dynamically sorted and filtered, and headers can be added dynamically depending on the row content. It also allows keyboard and mouse navigation and selection like a typical list.

Using GtkListBox is often an alternative to `TreeView`, especially when the list contents has a more complicated layout than what is allowed by a `CellRenderer`, or when the contents is interactive (i.e. has a button in it).

Although a `ListBox` must have only `ListBoxRow` children you can add any kind of widget to it via `containerAdd`, and a `ListBoxRow` widget will automatically be inserted between the list and the widget.

`GtkListBoxRows` can be marked as activatable or selectable. If a row is activatable, ListBox::rowActivated will be emitted for it when the user tries to activate it. If it is selectable, the row will be marked as selected when the user tries to select it.

The GtkListBox widget was added in GTK+ 3.10.

# GtkListBox as GtkBuildable

The GtkListBox implementation of the `Buildable` interface supports setting a child as the placeholder by specifying “placeholder” as the “type” attribute of a `<child>` element. See `listBoxSetPlaceholder` for info.

# CSS nodes

### plain code

    list
    ╰── row[.activatable]

GtkListBox uses a single CSS node named list. Each GtkListBoxRow uses a single CSS node named row. The row nodes get the .activatable style class added when appropriate.

Synopsis

- newtype ListBox = ListBox (ManagedPtr ListBox)
- class (GObject o, IsDescendantOf ListBox o) => IsListBox o
- toListBox :: (MonadIO m, IsListBox o) => o -> m ListBox
- listBoxBindModel :: (HasCallStack, MonadIO m, IsListBox a, IsListModel b) => a -> Maybe b -> Maybe ListBoxCreateWidgetFunc -> m ()
- listBoxDragHighlightRow :: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) => a -> b -> m ()
- listBoxDragUnhighlightRow :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxGetActivateOnSingleClick :: (HasCallStack, MonadIO m, IsListBox a) => a -> m Bool
- listBoxGetAdjustment :: (HasCallStack, MonadIO m, IsListBox a) => a -> m Adjustment
- listBoxGetRowAtIndex :: (HasCallStack, MonadIO m, IsListBox a) => a -> Int32 -> m (Maybe ListBoxRow)
- listBoxGetRowAtY :: (HasCallStack, MonadIO m, IsListBox a) => a -> Int32 -> m (Maybe ListBoxRow)
- listBoxGetSelectedRow :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ListBoxRow
- listBoxGetSelectedRows :: (HasCallStack, MonadIO m, IsListBox a) => a -> m [ListBoxRow]
- listBoxGetSelectionMode :: (HasCallStack, MonadIO m, IsListBox a) => a -> m SelectionMode
- listBoxInsert :: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) => a -> b -> Int32 -> m ()
- listBoxInvalidateFilter :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxInvalidateHeaders :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxInvalidateSort :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxNew :: (HasCallStack, MonadIO m) => m ListBox
- listBoxPrepend :: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) => a -> b -> m ()
- listBoxSelectAll :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxSelectRow :: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) => a -> Maybe b -> m ()
- listBoxSelectedForeach :: (HasCallStack, MonadIO m, IsListBox a) => a -> ListBoxForeachFunc -> m ()
- listBoxSetActivateOnSingleClick :: (HasCallStack, MonadIO m, IsListBox a) => a -> Bool -> m ()
- listBoxSetAdjustment :: (HasCallStack, MonadIO m, IsListBox a, IsAdjustment b) => a -> Maybe b -> m ()
- listBoxSetFilterFunc :: (HasCallStack, MonadIO m, IsListBox a) => a -> Maybe ListBoxFilterFunc -> m ()
- listBoxSetHeaderFunc :: (HasCallStack, MonadIO m, IsListBox a) => a -> Maybe ListBoxUpdateHeaderFunc -> m ()
- listBoxSetPlaceholder :: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) => a -> Maybe b -> m ()
- listBoxSetSelectionMode :: (HasCallStack, MonadIO m, IsListBox a) => a -> SelectionMode -> m ()
- listBoxSetSortFunc :: (HasCallStack, MonadIO m, IsListBox a) => a -> Maybe ListBoxSortFunc -> m ()
- listBoxUnselectAll :: (HasCallStack, MonadIO m, IsListBox a) => a -> m ()
- listBoxUnselectRow :: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) => a -> b -> m ()
- constructListBoxActivateOnSingleClick :: (IsListBox o, MonadIO m) => Bool -> m (GValueConstruct o)
- getListBoxActivateOnSingleClick :: (MonadIO m, IsListBox o) => o -> m Bool
- setListBoxActivateOnSingleClick :: (MonadIO m, IsListBox o) => o -> Bool -> m ()
- constructListBoxSelectionMode :: (IsListBox o, MonadIO m) => SelectionMode -> m (GValueConstruct o)
- getListBoxSelectionMode :: (MonadIO m, IsListBox o) => o -> m SelectionMode
- setListBoxSelectionMode :: (MonadIO m, IsListBox o) => o -> SelectionMode -> m ()
- type ListBoxActivateCursorRowCallback = IO ()
- afterListBoxActivateCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxActivateCursorRowCallback) -> m SignalHandlerId
- onListBoxActivateCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxActivateCursorRowCallback) -> m SignalHandlerId
- type ListBoxMoveCursorCallback = MovementStep -> Int32 -> IO ()
- afterListBoxMoveCursor :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxMoveCursorCallback) -> m SignalHandlerId
- onListBoxMoveCursor :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxMoveCursorCallback) -> m SignalHandlerId
- type ListBoxRowActivatedCallback = ListBoxRow -> IO ()
- afterListBoxRowActivated :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowActivatedCallback) -> m SignalHandlerId
- onListBoxRowActivated :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowActivatedCallback) -> m SignalHandlerId
- type ListBoxRowSelectedCallback = Maybe ListBoxRow -> IO ()
- afterListBoxRowSelected :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowSelectedCallback) -> m SignalHandlerId
- onListBoxRowSelected :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowSelectedCallback) -> m SignalHandlerId
- type ListBoxSelectAllCallback = IO ()
- afterListBoxSelectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectAllCallback) -> m SignalHandlerId
- onListBoxSelectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectAllCallback) -> m SignalHandlerId
- type ListBoxSelectedRowsChangedCallback = IO ()
- afterListBoxSelectedRowsChanged :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectedRowsChangedCallback) -> m SignalHandlerId
- onListBoxSelectedRowsChanged :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectedRowsChangedCallback) -> m SignalHandlerId
- type ListBoxToggleCursorRowCallback = IO ()
- afterListBoxToggleCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxToggleCursorRowCallback) -> m SignalHandlerId
- onListBoxToggleCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxToggleCursorRowCallback) -> m SignalHandlerId
- type ListBoxUnselectAllCallback = IO ()
- afterListBoxUnselectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxUnselectAllCallback) -> m SignalHandlerId
- onListBoxUnselectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxUnselectAllCallback) -> m SignalHandlerId

# Exported types

newtype ListBox Source #

Memory-managed wrapper type.

Constructors

ListBox (ManagedPtr ListBox) |

#### Instances

Instances details

Eq ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox Methods (==) :: ListBox -> ListBox -> Bool Source # (/=) :: ListBox -> ListBox -> Bool Source #
GObject ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox
ManagedPtrNewtype ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox Methods toManagedPtr :: ListBox -> ManagedPtr ListBox Source #
TypedObject ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox Methods glibType :: IO GType Source #
HasParentTypes ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox
IsGValue (Maybe ListBox) Source # | Convert `ListBox` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.ListBox Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe ListBox -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe ListBox) Source #
type ParentTypes ListBox Source # |
Instance details Defined in GI.Gtk.Objects.ListBox type ParentTypes ListBox = '[Container, Widget, Object, ImplementorIface, Buildable]

class (GObject o, IsDescendantOf ListBox o) => IsListBox o Source #

Type class for types which can be safely cast to `ListBox`, for instance with `toListBox`.

#### Instances

Instances details

(GObject o, IsDescendantOf ListBox o) => IsListBox o Source # |
Instance details Defined in GI.Gtk.Objects.ListBox

toListBox :: (MonadIO m, IsListBox o) => o -> m ListBox Source #

Cast to `ListBox`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

activate, add, addAccelerator, addChild, addDeviceEvents, addEvents, addMnemonicLabel, addTickCallback, bindModel, bindProperty, bindPropertyFull, canActivateAccel, checkResize, childFocus, childGetProperty, childNotify, childNotifyByPspec, childSetProperty, childType, classPath, computeExpand, constructChild, createPangoContext, createPangoLayout, customFinished, customTagEnd, customTagStart, destroy, destroyed, deviceIsShadowed, dragBegin, dragBeginWithCoordinates, dragCheckThreshold, dragDestAddImageTargets, dragDestAddTextTargets, dragDestAddUriTargets, dragDestFindTarget, dragDestGetTargetList, dragDestGetTrackMotion, dragDestSet, dragDestSetProxy, dragDestSetTargetList, dragDestSetTrackMotion, dragDestUnset, dragGetData, dragHighlight, dragHighlightRow, dragSourceAddImageTargets, dragSourceAddTextTargets, dragSourceAddUriTargets, dragSourceGetTargetList, dragSourceSet, dragSourceSetIconGicon, dragSourceSetIconName, dragSourceSetIconPixbuf, dragSourceSetIconStock, dragSourceSetTargetList, dragSourceUnset, dragUnhighlight, dragUnhighlightRow, draw, ensureStyle, errorBell, event, forall, forceFloating, foreach, freezeChildNotify, freezeNotify, getv, grabAdd, grabDefault, grabFocus, grabRemove, hasDefault, hasFocus, hasGrab, hasRcStyle, hasScreen, hasVisibleFocus, hide, hideOnDelete, inDestruction, initTemplate, inputShapeCombineRegion, insert, insertActionGroup, intersect, invalidateFilter, invalidateHeaders, invalidateSort, isAncestor, isComposited, isDrawable, isFloating, isFocus, isSensitive, isToplevel, isVisible, keynavFailed, listAccelClosures, listActionPrefixes, listMnemonicLabels, map, mnemonicActivate, modifyBase, modifyBg, modifyCursor, modifyFg, modifyFont, modifyStyle, modifyText, notify, notifyByPspec, overrideBackgroundColor, overrideColor, overrideCursor, overrideFont, overrideSymbolicColor, parserFinished, path, prepend, propagateDraw, queueAllocate, queueComputeExpand, queueDraw, queueDrawArea, queueDrawRegion, queueResize, queueResizeNoRedraw, realize, ref, refSink, regionIntersect, registerWindow, remove, removeAccelerator, removeMnemonicLabel, removeTickCallback, renderIcon, renderIconPixbuf, reparent, resetRcStyles, resetStyle, resizeChildren, runDispose, selectAll, selectRow, selectedForeach, sendExpose, sendFocusChange, shapeCombineRegion, show, showAll, showNow, sizeAllocate, sizeAllocateWithBaseline, sizeRequest, stealData, stealQdata, styleAttach, styleGetProperty, thawChildNotify, thawNotify, translateCoordinates, triggerTooltipQuery, unmap, unparent, unrealize, unref, unregisterWindow, unselectAll, unselectRow, unsetFocusChain, unsetStateFlags, watchClosure.

#### Getters

getAccessible, getActionGroup, getActivateOnSingleClick, getAdjustment, getAllocatedBaseline, getAllocatedHeight, getAllocatedSize, getAllocatedWidth, getAllocation, getAncestor, getAppPaintable, getBorderWidth, getCanDefault, getCanFocus, getChildRequisition, getChildVisible, getChildren, getClip, getClipboard, getCompositeName, getData, getDeviceEnabled, getDeviceEvents, getDirection, getDisplay, getDoubleBuffered, getEvents, getFocusChain, getFocusChild, getFocusHadjustment, getFocusOnClick, getFocusVadjustment, getFontMap, getFontOptions, getFrameClock, getHalign, getHasTooltip, getHasWindow, getHexpand, getHexpandSet, getInternalChild, getMapped, getMarginBottom, getMarginEnd, getMarginLeft, getMarginRight, getMarginStart, getMarginTop, getModifierMask, getModifierStyle, getName, getNoShowAll, getOpacity, getPangoContext, getParent, getParentWindow, getPath, getPathForChild, getPointer, getPreferredHeight, getPreferredHeightAndBaselineForWidth, getPreferredHeightForWidth, getPreferredSize, getPreferredWidth, getPreferredWidthForHeight, getProperty, getQdata, getRealized, getReceivesDefault, getRequestMode, getRequisition, getResizeMode, getRootWindow, getRowAtIndex, getRowAtY, getScaleFactor, getScreen, getSelectedRow, getSelectedRows, getSelectionMode, getSensitive, getSettings, getSizeRequest, getState, getStateFlags, getStyle, getStyleContext, getSupportMultidevice, getTemplateChild, getTooltipMarkup, getTooltipText, getTooltipWindow, getToplevel, getValign, getValignWithBaseline, getVexpand, getVexpandSet, getVisible, getVisual, getWindow.

#### Setters

setAccelPath, setActivateOnSingleClick, setAdjustment, setAllocation, setAppPaintable, setBorderWidth, setBuildableProperty, setCanDefault, setCanFocus, setChildVisible, setClip, setCompositeName, setData, setDataFull, setDeviceEnabled, setDeviceEvents, setDirection, setDoubleBuffered, setEvents, setFilterFunc, setFocusChain, setFocusChild, setFocusHadjustment, setFocusOnClick, setFocusVadjustment, setFontMap, setFontOptions, setHalign, setHasTooltip, setHasWindow, setHeaderFunc, setHexpand, setHexpandSet, setMapped, setMarginBottom, setMarginEnd, setMarginLeft, setMarginRight, setMarginStart, setMarginTop, setName, setNoShowAll, setOpacity, setParent, setParentWindow, setPlaceholder, setProperty, setRealized, setReallocateRedraws, setReceivesDefault, setRedrawOnAllocate, setResizeMode, setSelectionMode, setSensitive, setSizeRequest, setSortFunc, setState, setStateFlags, setStyle, setSupportMultidevice, setTooltipMarkup, setTooltipText, setTooltipWindow, setValign, setVexpand, setVexpandSet, setVisible, setVisual, setWindow.

## bindModel

listBoxBindModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsListModel b) |
=> a | `box`: a `ListBox`
-> Maybe b | `model`: the `ListModel` to be bound to `box`
-> Maybe ListBoxCreateWidgetFunc | `createWidgetFunc`: a function that creates widgets for items or `Nothing` in case you also passed `Nothing` as `model`
-> m () |

Binds `model` to `box`.

If `box` was already bound to a model, that previous binding is destroyed.

The contents of `box` are cleared and then filled with widgets that represent items from `model`. `box` is updated whenever `model` changes. If `model` is `Nothing`, `box` is left empty.

It is undefined to add or remove widgets directly (for example, with `listBoxInsert` or `containerAdd`) while `box` is bound to a model.

Note that using a model is incompatible with the filtering and sorting functionality in GtkListBox. When using a model, filtering and sorting should be implemented by the model.

Since: 3.16

## dragHighlightRow

listBoxDragHighlightRow Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) |
=> a | `box`: a `ListBox`
-> b | `row`: a `ListBoxRow`
-> m () |

This is a helper function for implementing DnD onto a `ListBox`. The passed in `row` will be highlighted via `widgetDragHighlight`, and any previously highlighted row will be unhighlighted.

The row will also be unhighlighted when the widget gets a drag leave event.

Since: 3.10

## dragUnhighlightRow

listBoxDragUnhighlightRow Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

If a row has previously been highlighted via `listBoxDragHighlightRow` it will have the highlight removed.

Since: 3.10

## getActivateOnSingleClick

listBoxGetActivateOnSingleClick Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m Bool | Returns: `True` if rows are activated on single click, `False` otherwise

Returns whether rows activate on single clicks.

Since: 3.10

## getAdjustment

listBoxGetAdjustment Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m Adjustment | Returns: the adjustment

Gets the adjustment (if any) that the widget uses to for vertical scrolling.

Since: 3.10

## getRowAtIndex

listBoxGetRowAtIndex Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Int32 | `index_`: the index of the row
-> m (Maybe ListBoxRow) | Returns: the child `Widget` or `Nothing`

Gets the n-th child in the list (not counting headers). If `index_` is negative or larger than the number of items in the list, `Nothing` is returned.

Since: 3.10

## getRowAtY

listBoxGetRowAtY Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Int32 | `y`: position
-> m (Maybe ListBoxRow) | Returns: the row or `Nothing` in case no row exists for the given y coordinate.

Gets the row at the `y` position.

Since: 3.10

## getSelectedRow

listBoxGetSelectedRow Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m ListBoxRow | Returns: the selected row

Gets the selected row.

Note that the box may allow multiple selection, in which case you should use `listBoxSelectedForeach` to find all selected rows.

Since: 3.10

## getSelectedRows

listBoxGetSelectedRows Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m [ListBoxRow] | Returns: A `List` containing the `Widget` for each selected child. Free with `g_list_free()` when done.

Creates a list of all selected children.

Since: 3.14

## getSelectionMode

listBoxGetSelectionMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m SelectionMode | Returns: a `SelectionMode`

Gets the selection mode of the listbox.

Since: 3.10

## insert

listBoxInsert Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) |
=> a | `box`: a `ListBox`
-> b | `child`: the `Widget` to add
-> Int32 | `position`: the position to insert `child` in
-> m () |

Insert the `child` into the `box` at `position`. If a sort function is set, the widget will actually be inserted at the calculated position and this function has the same effect of `containerAdd`.

If `position` is -1, or larger than the total number of items in the `box`, then the `child` will be appended to the end.

Since: 3.10

## invalidateFilter

listBoxInvalidateFilter Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

Update the filtering for all rows. Call this when result of the filter function on the `box` is changed due to an external factor. For instance, this would be used if the filter function just looked for a specific search string and the entry with the search string has changed.

Since: 3.10

## invalidateHeaders

listBoxInvalidateHeaders Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

Update the separators for all rows. Call this when result of the header function on the `box` is changed due to an external factor.

Since: 3.10

## invalidateSort

listBoxInvalidateSort Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

Update the sorting for all rows. Call this when result of the sort function on the `box` is changed due to an external factor.

Since: 3.10

## new

listBoxNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m ListBox | Returns: a new `ListBox`

Creates a new `ListBox` container.

Since: 3.10

## prepend

listBoxPrepend Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) |
=> a | `box`: a `ListBox`
-> b | `child`: the `Widget` to add
-> m () |

Prepend a widget to the list. If a sort function is set, the widget will actually be inserted at the calculated position and this function has the same effect of `containerAdd`.

Since: 3.10

## selectAll

listBoxSelectAll Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

Select all children of `box`, if the selection mode allows it.

Since: 3.14

## selectRow

listBoxSelectRow Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) |
=> a | `box`: a `ListBox`
-> Maybe b | `row`: The row to select or `Nothing`
-> m () |

Make `row` the currently selected row.

Since: 3.10

## selectedForeach

listBoxSelectedForeach Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> ListBoxForeachFunc | `func`: the function to call for each selected child
-> m () |

Calls a function for each selected child.

Note that the selection cannot be modified from within this function.

Since: 3.14

## setActivateOnSingleClick

listBoxSetActivateOnSingleClick Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Bool | `single`: a boolean
-> m () |

If `single` is `True`, rows will be activated when you click on them, otherwise you need to double-click.

Since: 3.10

## setAdjustment

listBoxSetAdjustment Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsAdjustment b) |
=> a | `box`: a `ListBox`
-> Maybe b | `adjustment`: the adjustment, or `Nothing`
-> m () |

Sets the adjustment (if any) that the widget uses to for vertical scrolling. For instance, this is used to get the page size for PageUp/Down key handling.

In the normal case when the `box` is packed inside a `ScrolledWindow` the adjustment from that will be picked up automatically, so there is no need to manually do that.

Since: 3.10

## setFilterFunc

listBoxSetFilterFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Maybe ListBoxFilterFunc | `filterFunc`: callback that lets you filter which rows to show
-> m () |

By setting a filter function on the `box` one can decide dynamically which of the rows to show. For instance, to implement a search function on a list that filters the original list to only show the matching rows.

The `filterFunc` will be called for each row after the call, and it will continue to be called each time a row changes (via `listBoxRowChanged`) or when `listBoxInvalidateFilter` is called.

Note that using a filter function is incompatible with using a model (see `listBoxBindModel`).

Since: 3.10

## setHeaderFunc

listBoxSetHeaderFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Maybe ListBoxUpdateHeaderFunc | `updateHeader`: callback that lets you add row headers
-> m () |

By setting a header function on the `box` one can dynamically add headers in front of rows, depending on the contents of the row and its position in the list. For instance, one could use it to add headers in front of the first item of a new kind, in a list sorted by the kind.

The `updateHeader` can look at the current header widget using `listBoxRowGetHeader` and either update the state of the widget as needed, or set a new one using `listBoxRowSetHeader`. If no header is needed, set the header to `Nothing`.

Note that you may get many calls `updateHeader` to this for a particular row when e.g. changing things that don’t affect the header. In this case it is important for performance to not blindly replace an existing header with an identical one.

The `updateHeader` function will be called for each row after the call, and it will continue to be called each time a row changes (via `listBoxRowChanged`) and when the row before changes (either by `listBoxRowChanged` on the previous row, or when the previous row becomes a different row). It is also called for all rows when `listBoxInvalidateHeaders` is called.

Since: 3.10

## setPlaceholder

listBoxSetPlaceholder Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsWidget b) |
=> a | `box`: a `ListBox`
-> Maybe b | `placeholder`: a `Widget` or `Nothing`
-> m () |

Sets the placeholder widget that is shown in the list when it doesn't display any visible children.

Since: 3.10

## setSelectionMode

listBoxSetSelectionMode Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> SelectionMode | `mode`: The `SelectionMode`
-> m () |

Sets how selection works in the listbox. See `SelectionMode` for details.

Since: 3.10

## setSortFunc

listBoxSetSortFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> Maybe ListBoxSortFunc | `sortFunc`: the sort function
-> m () |

By setting a sort function on the `box` one can dynamically reorder the rows of the list, based on the contents of the rows.

The `sortFunc` will be called for each row after the call, and will continue to be called each time a row changes (via `listBoxRowChanged`) and when `listBoxInvalidateSort` is called.

Note that using a sort function is incompatible with using a model (see `listBoxBindModel`).

Since: 3.10

## unselectAll

listBoxUnselectAll Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a) |
=> a | `box`: a `ListBox`
-> m () |

Unselect all children of `box`, if the selection mode allows it.

Since: 3.14

## unselectRow

listBoxUnselectRow Source #

Arguments

:: (HasCallStack, MonadIO m, IsListBox a, IsListBoxRow b) |
=> a | `box`: a `ListBox`
-> b | `row`: the row to unselected
-> m () |

Unselects a single row of `box`, if the selection mode allows it.

Since: 3.14

# Properties

## activateOnSingleClick

No description available in the introspection data.

constructListBoxActivateOnSingleClick :: (IsListBox o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`activate-on-single-click`” property. This is rarely needed directly, but it is used by `new`.

getListBoxActivateOnSingleClick :: (MonadIO m, IsListBox o) => o -> m Bool Source #

Get the value of the “`activate-on-single-click`” property. When overloading is enabled, this is equivalent to

    get listBox #activateOnSingleClick

setListBoxActivateOnSingleClick :: (MonadIO m, IsListBox o) => o -> Bool -> m () Source #

Set the value of the “`activate-on-single-click`” property. When overloading is enabled, this is equivalent to

    set listBox [ #activateOnSingleClick := value ]

## selectionMode

No description available in the introspection data.

constructListBoxSelectionMode :: (IsListBox o, MonadIO m) => SelectionMode -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`selection-mode`” property. This is rarely needed directly, but it is used by `new`.

getListBoxSelectionMode :: (MonadIO m, IsListBox o) => o -> m SelectionMode Source #

Get the value of the “`selection-mode`” property. When overloading is enabled, this is equivalent to

    get listBox #selectionMode

setListBoxSelectionMode :: (MonadIO m, IsListBox o) => o -> SelectionMode -> m () Source #

Set the value of the “`selection-mode`” property. When overloading is enabled, this is equivalent to

    set listBox [ #selectionMode := value ]

# Signals

## activateCursorRow

type ListBoxActivateCursorRowCallback = IO () Source #

No description available in the introspection data.

afterListBoxActivateCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxActivateCursorRowCallback) -> m SignalHandlerId Source #

Connect a signal handler for the activateCursorRow signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #activateCursorRow callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxActivateCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxActivateCursorRowCallback) -> m SignalHandlerId Source #

Connect a signal handler for the activateCursorRow signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #activateCursorRow callback

## moveCursor

type ListBoxMoveCursorCallback = MovementStep -> Int32 -> IO () Source #

No description available in the introspection data.

afterListBoxMoveCursor :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxMoveCursorCallback) -> m SignalHandlerId Source #

Connect a signal handler for the moveCursor signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #moveCursor callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxMoveCursor :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxMoveCursorCallback) -> m SignalHandlerId Source #

Connect a signal handler for the moveCursor signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #moveCursor callback

## rowActivated

type ListBoxRowActivatedCallback Source #

Arguments

= ListBoxRow | `row`: the activated row
-> IO () |

The rowActivated signal is emitted when a row has been activated by the user.

Since: 3.10

afterListBoxRowActivated :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowActivatedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowActivated signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #rowActivated callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxRowActivated :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowActivatedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowActivated signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #rowActivated callback

## rowSelected

type ListBoxRowSelectedCallback Source #

Arguments

= Maybe ListBoxRow | `row`: the selected row
-> IO () |

The rowSelected signal is emitted when a new row is selected, or (with a `Nothing` `row`) when the selection is cleared.

When the `box` is using `GTK_SELECTION_MULTIPLE`, this signal will not give you the full picture of selection changes, and you should use the ListBox::selectedRowsChanged signal instead.

Since: 3.10

afterListBoxRowSelected :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowSelectedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowSelected signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #rowSelected callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxRowSelected :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxRowSelectedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the rowSelected signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #rowSelected callback

## selectAll

type ListBoxSelectAllCallback = IO () Source #

The selectAll signal is a [keybinding signal][GtkBindingSignal] which gets emitted to select all children of the box, if the selection mode permits it.

The default bindings for this signal is Ctrl-a.

Since: 3.14

afterListBoxSelectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectAllCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectAll signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #selectAll callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxSelectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectAllCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectAll signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #selectAll callback

## selectedRowsChanged

type ListBoxSelectedRowsChangedCallback = IO () Source #

The selectedRowsChanged signal is emitted when the set of selected rows changes.

Since: 3.14

afterListBoxSelectedRowsChanged :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectedRowsChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectedRowsChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #selectedRowsChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxSelectedRowsChanged :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxSelectedRowsChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the selectedRowsChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #selectedRowsChanged callback

## toggleCursorRow

type ListBoxToggleCursorRowCallback = IO () Source #

No description available in the introspection data.

afterListBoxToggleCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxToggleCursorRowCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toggleCursorRow signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #toggleCursorRow callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxToggleCursorRow :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxToggleCursorRowCallback) -> m SignalHandlerId Source #

Connect a signal handler for the toggleCursorRow signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #toggleCursorRow callback

## unselectAll

type ListBoxUnselectAllCallback = IO () Source #

The unselectAll signal is a [keybinding signal][GtkBindingSignal] which gets emitted to unselect all children of the box, if the selection mode permits it.

The default bindings for this signal is Ctrl-Shift-a.

Since: 3.14

afterListBoxUnselectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxUnselectAllCallback) -> m SignalHandlerId Source #

Connect a signal handler for the unselectAll signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listBox #unselectAll callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListBoxUnselectAll :: (IsListBox a, MonadIO m) => a -> ((?self :: a) => ListBoxUnselectAllCallback) -> m SignalHandlerId Source #

Connect a signal handler for the unselectAll signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listBox #unselectAll callback